/*
 * spec.canvas_id : id of the canvas
 */
var GL, CV, DBG=false;
var Contexte=(function() {
    return {

        instance: function(spec) {
            var canvas=document.getElementById(spec.canvas_id);
           
            CV=canvas;
            try {
		GL = canvas.getContext("experimental-webgl", {antialias: true});
            } catch (e) {
		alert("Vous n'êtes pas compatibles webgl !") ;
                return false;
            } ;
            
            var shaders=Shaders.instance({});
            var vue=Vue.instance({camera: SETTINGS.camera.pos0, theta: SETTINGS.camera.theta0, phi: SETTINGS.camera.phi0, angle: 35, zMin: 1, zMax: 700});
            vue.plein_ecran();            
            var navigation=Navigation.instance({vue: vue});
            navigation.set();
            navigation.blocage_souris();
            var scene=Scene.instance({vue: vue, navigation: navigation});
            var texture=Texture.instance({url: "images/metal_echiquier.jpg"});


            var mat=Materiau.instance({ka: 0,
                                   kd: 1.5,
                                   ks: 5,
                                   phong: 14,
                                   couleur: [1,1,1]});
           
                               
            var lumiere=LumiereDirectionnelle.instance({direction: [0,-1,0]});
            scene.add_lumiere(lumiere);

            var terrain=BlenderObjet.instance({url: "blender/ground2.json", materiau: mat, texture: texture,
                onloaded: function(ground) {
                    scene.add_objet(ground);
                }});

            scene.draw(0);
            return true;
        }
    }
})();



