/*
 * spec.ka : ambiant
 * spec.kd : diffus
 * spec.ks: speculaire
 * phong: coefficient de Phong
 * couleur: couleur - vec3
 */
var Materiau=(function () {
    return {
        instance: function(spec) {
           var phongVec=[spec.ka || 0,spec.kd || 0,spec.ks || 0,spec.phong || 0],
               couleur=spec.couleur || [0,0,0];

            var that={
                   set_ka: function(ka) {
                       phongVec[0]=parseFloat(ka);
                   },
                   set_kd: function(kd) {
                       phongVec[1]=parseFloat(kd);
                   },
                   set_ks: function(ks) {
                       phongVec[2]=parseFloat(ks);
                   },
                   set_phong: function(phong) {
                       phongVec[3]=parseFloat(phong);
                   },
                   set_couleur: function(couleur) {
                       couleur=couleur;
                   },
                   set_rouge: function(r) {
                       couleur[0]=parseFloat(r);
                   },
                   set_vert: function(v) {
                       couleur[1]=parseFloat(v);
                   },
                   set_bleu: function(b) {
                       couleur[2]=parseFloat(b);
                   },
                   draw: function() {
                       SHADERS.set_couleur(couleur);
                       SHADERS.set_phong(phongVec);
                       return true;
                   }
            };
            return that;
        }
    };
})();


