/*
 * spec.vue: vue associée à la navigation
 */
var Navigation=(function () {
    return {
        instance: function(spec) {
            var sensibilite_x=SETTINGS.navigation.sensitivity_mouse,
                sensibilite_y=SETTINGS.navigation.sensitivity_mouse,
                sensibilite_touche=SETTINGS.navigation.sensitivity_keyboard;

            var touches=[], eventHandlers=[], clic=false, mouseX0=0, mouseY0=0, blocage=false, dt=0;
            var add_eventHandler=function(type, handler) {
                window.addEventListener(type, handler, false);
                eventHandlers.push({type: type, handler: handler});
            }

            var mouseDown=function(e) {
                if (blocage) return false;
                clic=true;
                mouseX0=e.pageX;
                mouseY0=e.pageY;
                e.preventDefault();
                return false;
            }

            var mouseUp=function(e) {
                clic=false;
            }

            var mouseMove=function(e) {
                if (!clic && !blocage) return false;
                var dX=(blocage?(e.movementX||e.mozMovementX||e.webkitMovementX||0):(e.pageX-mouseX0))*sensibilite_x,
                    dY=(blocage?(e.movementY||e.mozMovementY||e.webkitMovementY||0):(e.pageY-mouseY0))*sensibilite_y;
                spec.vue.moveAngles(dX, dY);
                if (!blocage) {
                    mouseX0=e.pageX;
                    mouseY0=e.pageY;
                }
            }

            var keyDown=function(e) {
                e.preventDefault();
                if (touches.indexOf(e.keyCode)!=-1) return false;
                touches.push(e.keyCode);                
                return false;
            }

            var keyUp=function(e) {
                var position=touches.indexOf(e.keyCode);
                if (position!=-1) touches.splice(position, 1);
                e.preventDefault();
                return false;
            }

            var dragStart=function(e){
                e.preventDefault();
                return false;
            }

            var manage_touche=function(touche) {
                switch(touche) {
                    case 37: //fleche de gauche
                        spec.vue.translateXVue(sensibilite_touche)*dt;
                    break;
                    case 39: //fleche de droite
                        spec.vue.translateXVue(-sensibilite_touche)*dt;
                    break;
                    case 38: //fleche du haut
                        spec.vue.translateZVue(-sensibilite_touche)*dt;
                    break;
                    case 40: //fleche du bas
                        spec.vue.translateZVue(sensibilite_touche)*dt;
                    break;
                    case 32: //space bar
                        SCENE.jump();
                    break;

                }
            }

            var pleinEcranChange=function(e) {
                if (document.webkitFullscreenElement === CV ||
                    document.mozFullscreenElement === CV ||
                    document.mozFullScreenElement === CV) {
                    //on est en plein écran -> activation du bloquage souris
                    CV.requestPointerLock = CV.requestPointerLock    ||
                                            CV.mozRequestPointerLock ||
                                            CV.mozRequestFullScreen ||
                                            CV.webkitRequestPointerLock;
                    CV.requestPointerLock();
                }
            }

            var bloqueSouris=function() {
              CV.requestFullscreen = CV.requestFullscreen    ||
                                     CV.mozRequestFullscreen ||
                                     CV.mozRequestFullScreen ||
                                     CV.webkitRequestFullscreen;
              CV.requestFullscreen();
            }

            var blocageSourisChange = function(e) {
                blocage=(document.mozPointerLockElement === CV ||
                         document.webkitPointerLockElement === CV);
            }

            var that={
                   drawPhysics: function(dtext) {
                        dt=dtext;
                        touches.map(manage_touche);
                   },

                   set: function() {
                       add_eventHandler("mousedown", mouseDown);
                       add_eventHandler("mouseup", mouseUp);
                       add_eventHandler("mousemove", mouseMove);
                       add_eventHandler("keyup", keyUp);
                       add_eventHandler("keydown", keyDown);
                   },

                   unset: function() {
                       eventHandlers.map(function(e) { window.removeEventListener(e.type, e.handler, false);})
                       eventHandlers=[];
                   },

                   blocage_souris: function() {
                       document.addEventListener('fullscreenchange', pleinEcranChange, false);
                       document.addEventListener('mozfullscreenchange', pleinEcranChange, false);
                       document.addEventListener('webkitfullscreenchange', pleinEcranChange, false);
                       document.addEventListener('pointerlockchange', blocageSourisChange, false);
                       document.addEventListener('mozpointerlockchange', blocageSourisChange, false);
                       document.addEventListener('webkitpointerlockchange', blocageSourisChange, false);
                       document.getElementById("bloqueSouris").onclick=bloqueSouris;
                   }
            };
            return that;
        }
    };
})();


