/*
 * spec.maillage : maillage de l'objet (type Maillage)
 * spec.matrix: matrice de mouvement (defaut : I4)
 * spec.texture : Texture
 * spec.materiau : materiau
 * spec.ombre: true/false
 */
var Objet=(function() {
    return {
        instance: function(spec) {
            spec.matrix=spec.matrix || lib_matrix4.get_I4();
            var texture=spec.texture || false,
                matrix=lib_matrix4.copyNew(spec.matrix),
                materiau=spec.materiau || false,
                ombre=spec.ombre || false;

            var that={
                drawDistance: function() {
                    SHADERS.set_matriceObjet_distance(matrix);
                    spec.maillage.drawDistance();
                },

                draw: function() {
                    if (texture) texture.draw();
                    if (materiau) materiau.draw();
                    SHADERS.set_matriceObjet(matrix);
                    spec.maillage.draw();
                },
                rotateX: function(dTheta) {
                    lib_matrix_rot4.rotateX(matrix, dTheta);
                },
                rotateY: function(dTheta) {
                    lib_matrix_rot4.rotateY(matrix, dTheta);
                },
                rotateZ: function(dTheta) {
                    lib_matrix_rot4.rotateZ(matrix, dTheta);
                },

                change_texture: function(text) {
                    texture=text;
                },

                drawPhysics: false,

                set_physics: function(phyFunc) {
                    that.drawPhysics=phyFunc;
                },
                loaded: true
            };
            return that;
        }
    }
})();

