/*
 * spec: empty
 */
var SHADERS;
var Shaders=(function (){

    var get_shader=function(source, type, infoString) {
            var shader = GL.createShader(type);
            GL.shaderSource(shader, source);
            GL.compileShader(shader);
            if (!GL.getShaderParameter(shader, GL.COMPILE_STATUS)) {
                alert(infoString+" : "+GL.getShaderInfoLog(shader));
                return false;
            }
            return shader;
    };

    var shader_vertex_source="$SHADER_VERTEX$",
        shader_fragment_source="$SHADER_FRAGMENT$";

    var shader_vertex,
        shader_fragment,
        shader_program;

    var matrice_vue,
        matrice_projection,
        matrice_objet,
        position,
        normal,
        UV,
        couleur,
        sampler,
        camera,
        lumiere_direction,  
        phong;


var shader_vertex_source_distance="$SHADER_VERTEX_DISTANCE$",
    shader_fragment_source_distance="$SHADER_FRAGMENT_DISTANCE$";

var shader_vertex_distance,
    shader_fragment_distance,
    shader_program_distance;

var matrice_vue_distance,
    matrice_projection_distance,
    matrice_objet_distance,
    position_distance,
    r_min_distance, r_max_distance;

    var that={
        instance: function(spec) {
            shader_vertex=get_shader(shader_vertex_source, GL.VERTEX_SHADER, "vertex shader ");
            shader_fragment=get_shader(shader_fragment_source, GL.FRAGMENT_SHADER, "fragment shader");

            shader_program=GL.createProgram();

            GL.attachShader(shader_program, shader_vertex);
            GL.attachShader(shader_program, shader_fragment);

            GL.linkProgram(shader_program);

            matrice_projection = GL.getUniformLocation(shader_program, "matrice_projection");
            matrice_vue = GL.getUniformLocation(shader_program, "matrice_vue");
            matrice_objet = GL.getUniformLocation(shader_program, "matrice_objet");
            phong = GL.getUniformLocation(shader_program, "phong");            
            couleur = GL.getUniformLocation(shader_program, "couleur");
            camera = GL.getUniformLocation(shader_program, "camera");
            lumiere_direction=GL.getUniformLocation(shader_program, "lumiere_direction");
            sampler = GL.getUniformLocation(shader_program, "sampler");

            position = GL.getAttribLocation(shader_program, "position");
            normal = GL.getAttribLocation(shader_program, "normal");
            UV = GL.getAttribLocation(shader_program, "UV");

            GL.enableVertexAttribArray(position);
            GL.enableVertexAttribArray(normal);
            GL.enableVertexAttribArray(UV);

            //GL.useProgram(shader_program);


            // =================================== DISTANCE SHADER =============================================
            shader_vertex_distance=get_shader(shader_vertex_source_distance, GL.VERTEX_SHADER, "vertex shader distance ");
            shader_fragment_distance=get_shader(shader_fragment_source_distance, GL.FRAGMENT_SHADER, "fragment shader distance");

            shader_program_distance=GL.createProgram();

            GL.attachShader(shader_program_distance, shader_vertex_distance);
            GL.attachShader(shader_program_distance, shader_fragment_distance);

            GL.linkProgram(shader_program_distance);

            matrice_projection_distance = GL.getUniformLocation(shader_program_distance, "matrice_projection");
            matrice_vue_distance = GL.getUniformLocation(shader_program_distance, "matrice_vue");
            matrice_objet_distance = GL.getUniformLocation(shader_program_distance, "matrice_objet");
            r_min_distance=GL.getUniformLocation(shader_program_distance, "r_min");
            r_max_distance=GL.getUniformLocation(shader_program_distance, "r_max");

            position_distance = GL.getAttribLocation(shader_program_distance, "position");
            //GL.enableVertexAttribArray(position_distance);

            GL.useProgram(shader_program);
        },

        //PHYSICS SHADER
        set_physicShader: function() {
            GL.disableVertexAttribArray(position);
            GL.disableVertexAttribArray(normal);
            GL.disableVertexAttribArray(UV);

            GL.useProgram(shader_program_distance);
            GL.enableVertexAttribArray(position_distance);
        },
        set_matriceProjection_distance: function(matrice){
            GL.uniformMatrix4fv(matrice_projection_distance, false, matrice);
        },
        set_matriceVue_distance: function(matrice) {
            GL.uniformMatrix4fv(matrice_vue_distance, false, matrice);
        },
        set_matriceObjet_distance: function(matrice) {
            GL.uniformMatrix4fv(matrice_objet_distance, false, matrice);
        },
        set_vertexPointers_distance: function() {
            GL.vertexAttribPointer(position_distance, 3, GL.FLOAT, false,32,0) ;
        },
        set_rminmax: function(r_min, r_max){
            GL.uniform1f(r_min_distance, r_min),
            GL.uniform1f(r_max_distance, r_max);
        },

        //DEFAULT SHADER
        set_defaultShader: function()  {
            GL.disableVertexAttribArray(position_distance);

            GL.useProgram(shader_program);

            GL.enableVertexAttribArray(position);
            GL.enableVertexAttribArray(normal);
            GL.enableVertexAttribArray(UV);
        },
        set_matriceProjection: function(matrice) {
            GL.uniformMatrix4fv(matrice_projection, false, matrice);
        },
        set_matriceVue: function(matrice) {
            GL.uniformMatrix4fv(matrice_vue, false, matrice);
        },
        set_matriceObjet: function(matrice) {
            GL.uniformMatrix4fv(matrice_objet, false, matrice);
        },
        set_phong: function(phongVec) {
            GL.uniform4fv(phong, phongVec);
        },        
        set_couleur: function(c) {           
            GL.uniform3fv(couleur, c);
        },
        set_camera: function(c) {
            GL.uniform3fv(camera, c);
        },
        set_lumiereDirection: function(l) {
           GL.uniform3fv(lumiere_direction,l);
        },
        set_vertexPointers: function() {
            GL.vertexAttribPointer(position, 3, GL.FLOAT, false,32,0) ;
            GL.vertexAttribPointer(normal, 3, GL.FLOAT, false,32,12) ;
            GL.vertexAttribPointer(UV, 2, GL.FLOAT, false,32,24) ;
        },

        set_samplers: function() {
            GL.uniform1i(sampler, 0);
        }
    };
    SHADERS=that;
    return that;

})();


