var lib_matrix_projection={
    get: function(angle, a, zMin, zMax) {
        var tan=Math.tan(lib_maths.degToRad(0.5*angle)),
            A=-(zMax+zMin)/(zMax-zMin),
            B=(-2*zMax*zMin)/(zMax-zMin);

        return [
            .5/tan, 0 ,   0, 0,
            0, .5*a/tan,  0, 0,
            0, 0,         A, -1,
            0, 0,         B, 0
        ];
    },

    getOrtho: function(largeur, a, zMin, zMax) {        
        var hauteur=a*largeur;

        return [
            1/largeur, 0 , 0, 0,
            0, 1/hauteur,  0, 0,
            0, 0, -2/(zMax-zMin),0,
            0, 0,  -(zMin+zMax)/(zMax-zMin), 1
        ];
    },

    cubeMatrices: function(zMin, zMax) { // chouffer dev/cubemap.gif

        var a=1,
            A=-(zMax+zMin)/(zMax-zMin),
            B=(-2*zMax*zMin)/(zMax-zMin);
        return[
        [a, 0,   0,  0, //proj normale suivant (x,y,z) -  Face4 - FRONT
         0,   a, 0,  0,
         0,   0,   A, -1,
         0,   0,   B,  0],

        [-a, 0,   0,  0, //Face 5 - suivant (-x,y,-z) - BACK
         0,   a, 0,  0,
         0,   0,   -A, 1,
         0,   0,   B,  0],

        [a, 0,   0,  0, //Face 3 - suivant (x,z,-y) - BOTTOM
         0,   0,  A,  -1,
         0,   -a,  0, 0,
         0,   0,   B,  0],

        [a, 0,   0,  0, //Face 2 - suivant (x,-z,y) -TOP
         0,   0,  -A,  1,
         0,   a, 0, 0,
         0,   0,   B,  0],

        [0, 0,  A,  -1, //Face 1 - suivant (z,y,-x) - LEFT
         0,   a, 0,  0,
         -a,   0,  0, 0,
         0,   0,   B,  0],

        [0, 0,   -A,  1, //Face 0 - suivant (-z,y,x) -RIGHT
         0,   a, 0,  0,
         a,   0,  0, 0,
         0,   0,   B,  0]
    ]},

    cubePos: function(m, v) {
        var zou=[
            m[0]*v[0]+m[4]*v[1]+m[8]*v[2],
            m[1]*v[0]+m[5]*v[1]+m[9]*v[2],
            m[2]*v[0]+m[6]*v[1]+m[10]*v[2]+m[14],
            m[3]*v[0]+m[7]*v[1]+m[11]*v[2]
        ]
        zou[0]/=zou[3];
        zou[1]/=zou[3];
        zou[2]/=zou[3];
        return zou;
    },

    debugCubeMatrice: function(s) {
        return [
            [s,s],
            [3*s, s],
            [s,0],
            [s, 2*s],
            [0,s],
            [2*s,s]
        ]
    }
};
